<template>
  <div
    class="w-full flex flex-col p-6 items-start gap-8 bg-surfaceBright border border-borderColor border-opacity-100 rounded-[8px]"
    :class="size === 'default' ? 'max-w-[758px]' : 'max-w-[360px]'"
  >
    <div class="flex flex-col items-start gap-[10px] self-stretch">
      <svn-pro-title medium :h5="size === 'default'" :h6="size === 'compact'">
        {{ title }}
      </svn-pro-title>

      <svn-pro-text subtitleLarge regular color="onSurfaceVariant">
        {{ description }}
      </svn-pro-text>
    </div>

    <div
      class="self-stretch"
      :class="
        size === 'default'
          ? 'flex justify-end items-center gap-2'
          : 'flex flex-col-reverse items-start gap-3 self-stretch'
      "
    >
      <template v-if="type === SvnProCardSectionQuizResultLearnType.good">
        <svn-pro-button
          v-if="hasSecondaryAction"
          variant="outlined"
          color="primary"
          :text="secondaryText"
          :class="size !== 'default' ? 'w-full' : ''"
          @click="secondaryClick"
        />

        <svn-pro-button
          variant="flat"
          color="primary"
          :text="primaryText"
          :class="size !== 'default' ? 'w-full' : ''"
          @click="primaryClick"
        />
      </template>
      <template v-else-if="type === SvnProCardSectionQuizResultLearnType.fail">
        <svn-pro-button
          v-if="hasTertiaryAction"
          variant="outlined"
          color="primary"
          :text="tertiaryText"
          :class="size !== 'default' ? 'w-full' : ''"
          @click="tertiaryClick"
        />

        <svn-pro-button
          variant="flat"
          color="primary"
          :text="primaryText"
          :class="size !== 'default' ? 'w-full' : ''"
          @click="primaryClick"
        />

        <svn-pro-button
          v-if="hasSecondaryAction"
          variant="outlined"
          color="primary"
          :text="secondaryText"
          :class="size !== 'default' ? 'w-full' : ''"
          @click="secondaryClick"
        />
      </template>
    </div>
  </div>
</template>

<script>
import SvnProText from '../../components/styles/SvnProText.vue';
import SvnProTitle from '../../components/styles/SvnProTitle.vue';
import SvnProButton from '../../components/button/SvnProButton.vue';
import { ComponentSizes } from '@/constants/types.js';

export const SvnProCardSectionQuizResultLearnType = Object.freeze({
  good: 'good',
  fail: 'fail',
});

export default {
  name: 'SvnProCardSectionQuizResultLearn',
  emits: ['primary-click', 'secondary-click', 'tertiary-click'],
  props: {
    type: {
      type: String,
      default: SvnProCardSectionQuizResultLearnType.good,
    },
    size: {
      type: String,
      default: ComponentSizes.default,
    },
    title: {
      type: String,
      default: 'Card Title',
    },
    description: {
      type: String,
      default:
        'You can take this quiz as many times as needed. 100% of correct answers will mark this module as acquired. ',
    },
    hasSecondaryAction: {
      type: Boolean,
      default: false,
    },
    hasTertiaryAction: {
      type: Boolean,
      default: false,
    },
    primaryText: {
      type: String,
      default: null,
    },
    secondaryText: {
      type: String,
      default: null,
    },
    tertiaryText: {
      type: String,
      default: null,
    },
  },
  methods: {
    primaryClick(e) {
      this.$emit('primary-click', e);
    },
    secondaryClick() {
      this.$emit('secondary-click');
    },
    tertiaryClick() {
      this.$emit('tertiary-click');
    },
  },
  computed: {
    SvnProCardSectionQuizResultLearnType() {
      return SvnProCardSectionQuizResultLearnType;
    },
  },
  components: {
    SvnProText,
    SvnProTitle,
    SvnProButton,
  },
};
</script>
